import m from 'mithril';
import './calendar.style.css';
import { Component, ComponentAttributes } from '../common/Component';
declare type ViewType = 'years' | 'months' | 'days';
declare type CalendarAttributes = ComponentAttributes & {
    value?: Date;
    focusOnDate?: Date;
    view?: ViewType;
    showWeekNumbers?: boolean;
    showWeekdayShortcuts?: boolean;
};
declare type CalendarEventTypes = {
    change: (value: Date | undefined) => void;
};
export declare class Calendar extends Component<CalendarAttributes, CalendarEventTypes> {
    private _toolbarTop;
    private _toolbarBottom;
    private _yearsOnPage;
    constructor(attrs?: CalendarAttributes);
    view(): m.Children | m.Vnode<unknown, unknown>;
    clear(): void;
    setValue(value: Date | undefined): void;
    getValue(): Date | undefined;
    prevPage(): void;
    nextPage(): void;
    setFocusDate(date: Date): void;
    private setView;
    private _getView;
    private _updateCurrentViewButton;
    private _getFocusDate;
    private _getDaysView;
    private _getMonthsView;
    private _getYearsView;
}
export {};
//# sourceMappingURL=Calendar.d.ts.map