import m from 'mithril';
import { IdType } from './Types';
import { EventEmitter, ValidEventTypes } from '../event-emitter/EventEmitter';
declare type ViewType = {
    view: () => m.Vnode<unknown, unknown> | m.Children;
};
export declare type ComponentAttributes = {
    id?: IdType;
    events?: ValidEventTypes;
};
export declare abstract class Component<A extends ComponentAttributes, E extends ValidEventTypes> implements ViewType {
    private readonly id;
    protected readonly attrs: A;
    protected node?: HTMLElement;
    protected modal: boolean;
    events: EventEmitter<E>;
    fitContainer: boolean;
    parent?: Component<ComponentAttributes, ValidEventTypes>;
    constructor(attrs?: A);
    getId(): IdType;
    mount(el?: HTMLElement | string): void;
    unmount(): void;
    abstract view(): m.Vnode<unknown, unknown> | m.Children;
}
export {};
//# sourceMappingURL=Component.d.ts.map