import m from 'mithril';
import { Control, ControlAttributes, ControlEventTypes } from '../common/Control';
import { Color } from '../../common/Types';
import './button.style.css';
declare type ButtonStyle = 'plain' | 'filled';
declare type ButtonSize = 'small' | 'medium' | 'large';
export type ButtonAttributes = ControlAttributes & {
    text?: string;
    color?: Color;
    style?: ButtonStyle;
    size?: ButtonSize;
    disabled?: boolean;
    round?: boolean;
    icon?: string;
    href?: string;
};
declare type ButtonEventTypes = ControlEventTypes;
export declare class Button extends Control<ButtonAttributes, ButtonEventTypes> {
    constructor(attrs?: ButtonAttributes);
    getColor(): Color;
    getStyle(): ButtonStyle;
    getSize(): ButtonSize;
    isDisabled(): boolean;
    setDisabled(disabled: boolean): boolean;
    getText(): string | undefined;
    setText(text: string | undefined): void;
    getIcon(): string | undefined;
    setIcon(icon: string | undefined): void;
    view(): m.Vnode<unknown, unknown> | m.Children;
}
export {};
//# sourceMappingURL=Button.d.ts.map