import { Component, ComponentAttributes } from '../../common/Component';
import { TooltipAttrs } from '../../messages/Tooltip';
export declare function getControlEvents(control: Component<ComponentAttributes, ControlEventTypes>): {
    onclick: (e: PointerEvent) => void;
    ondblclick: (e: PointerEvent) => void;
    onmouseover: (e: PointerEvent) => void;
    onmouseout: (e: PointerEvent) => void;
    onmousedown: (e: PointerEvent) => void;
    onmouseup: (e: PointerEvent) => void;
};
export type ControlAttributes = ComponentAttributes & {
    classNames?: string | string[];
    tooltip?: TooltipAttrs;
    hidden?: boolean;
};
export type ControlEventTypes = {
    click: (e: PointerEvent) => void;
    dblclick: (e: PointerEvent) => void;
    mouseover: (e: PointerEvent) => void;
    mouseout: (e: PointerEvent) => void;
    mousedown: (e: PointerEvent) => void;
    mouseup: (e: PointerEvent) => void;
};
export declare abstract class Control<A extends ControlAttributes, E extends ControlEventTypes> extends Component<A, E> {
    show(): void;
    hide(): void;
    isHidden(): boolean;
    constructor(attrs?: A);
}
//# sourceMappingURL=Control.d.ts.map