import { IData, IdType } from '../common/Types';
import { EventEmitter, ValidEventTypes } from '../event-emitter/EventEmitter';
import { DataItemType } from './Types';
export declare class Data<T extends DataItemType> implements IData<T> {
    private _items?;
    private _all;
    events: EventEmitter<ValidEventTypes>;
    private _filters;
    constructor();
    getItemById(id: IdType): T | undefined;
    getItemByIndex(index: number): T | undefined;
    clear(): void;
    add(item: T): T;
    load(items: T[]): void;
    loadAsync(data: T[] | Promise<T[]>): Promise<void>;
    getLength(): number;
    map<U>(callbackfn: (value: T, index: number, array: T[]) => U): U[];
    forEach<U>(callbackfn: (value: T, index: number, array: T[]) => U): void;
    applyFilter(predicate: (value: T, index: number, array: T[]) => unknown): void;
    clearFilters(): void;
    private _getItems;
}
//# sourceMappingURL=Data.d.ts.map