import { IData, IDataComponent, IdType } from '../common/Types';
import { EventEmitter, ValidEventTypes } from '../event-emitter/EventEmitter';
import { TreeDataItemType } from './Types';
export declare class TreeData implements IData<TreeDataItemType> {
    private items;
    private itemsMap;
    private itemsTopLevel;
    private itemsChildrenMap;
    events: EventEmitter<ValidEventTypes>;
    parent: IDataComponent<TreeDataItemType>;
    constructor(parent: IDataComponent<TreeDataItemType>);
    clear(): void;
    load(items: TreeDataItemType[]): void;
    loadAsync(data: TreeDataItemType[] | Promise<TreeDataItemType[]>): Promise<void>;
    forEach<T>(callback: (value: TreeDataItemType, index: number, array: TreeDataItemType[]) => T): T[];
    map<T>(callback: (value: TreeDataItemType, index: number, array: TreeDataItemType[]) => T): T[];
    getRootLevelItems(): TreeDataItemType[];
    getItemById(id: IdType): TreeDataItemType | undefined;
    getChildrenByParent(parentId: IdType): TreeDataItemType[];
    update(id: IdType, value: Partial<TreeDataItemType>): void;
}
//# sourceMappingURL=TreeData.d.ts.map