import m from 'mithril';
import { Editor, EditorAttributes, EditorEventTypes } from '../Editor';
import { Popup } from '../../popup/Popup';
import { List } from '../../list/List';
import { Box, Button, Toolbar } from '../..';
import { Data } from '../../data/Data';
import { TemplateResultType } from '../../common/Template';
import { DataItemType } from '../../data/Types';
import './combobox.style.css';
export declare type ComboboxAttributes<T> = EditorAttributes<T> & {
    placeholder?: string;
    readonly?: boolean;
    autoHidePopup?: boolean;
};
export declare type ComboboxDataItemType = DataItemType & {
    value?: string;
};
export declare abstract class ComboboxBase<T, A extends ComboboxAttributes<T>> extends Editor<T, A, EditorEventTypes<T>> {
    protected _popup: Popup;
    protected _list: List;
    protected _popupBox: Box;
    protected _toolbar: Toolbar;
    private _dropDownButton;
    protected _editingValue?: string;
    data: Data<ComboboxDataItemType>;
    constructor(attrs?: A);
    setValue(value?: T | undefined): void;
    showPopup(): void;
    setDisabled(disabled: boolean): boolean;
    protected _fixListView(): void;
    protected _itemTemplate(item: Record<string, unknown>): TemplateResultType;
    protected _getEditorAttrs(attrs: m.Attributes): m.Attributes;
    protected _getEditorContentAttrs(attrs: m.Attributes): m.Attributes;
    protected _getButtons(): Button[];
    protected _setFocus(focus: boolean): void;
    protected _getListFilteringFunction(): undefined | ((value: ComboboxDataItemType, index?: number, array?: ComboboxDataItemType[]) => unknown);
}
//# sourceMappingURL=ComboboxBase.d.ts.map