import m from 'mithril';
import { IdType } from '../../common/Types';
import { ComboboxAttributes, ComboboxBase, ComboboxDataItemType } from './ComboboxBase';
declare type MultiComboboxAttributes = ComboboxAttributes<IdType[]> & {
    showItemRemoveButton?: boolean;
    limit?: number;
    allowAddingOptions?: boolean;
};
export declare class MultiCombobox extends ComboboxBase<IdType[], MultiComboboxAttributes> {
    private _addOptionBtn;
    constructor(attrs?: MultiComboboxAttributes);
    addOption(value: string): void;
    getValue(): IdType[] | undefined;
    validate(value?: IdType[]): boolean;
    protected _getEditorAttrs(attrs: m.Attributes): m.Attributes;
    protected _getListFilteringFunction(): undefined | ((value: ComboboxDataItemType, index?: number, array?: ComboboxDataItemType[]) => unknown);
    protected valueView(): m.Children | m.Vnode<unknown, unknown>;
    protected controlView(): m.Children | m.Vnode<unknown, unknown>;
    protected _setEditingValue(value?: string | undefined): void;
}
export {};
//# sourceMappingURL=MultiCombobox.d.ts.map