import m from 'mithril';
import { Editor, EditorAttributes, EditorEventTypes } from '../Editor';
import { Button } from '../..';
import { dateFormats } from '../../tools/DateFormats';
declare type PopupMode = true | false | 'onlyByButton' | 'onlyByFocus';
export declare type InputDateAttributes = EditorAttributes<Date> & {
    placeholder?: string;
    readonly?: boolean;
    popup?: PopupMode;
    format?: keyof typeof dateFormats;
};
export declare class InputDate extends Editor<Date, InputDateAttributes, EditorEventTypes<Date>> {
    private _btnShowPopup;
    private _popup;
    private _calendar;
    constructor(attrs?: InputDateAttributes);
    showPopup(target: PointerEvent | HTMLElement): void;
    setValue(value?: Date | undefined): void;
    setDisabled(disabled: boolean): boolean;
    protected controlView(): m.Children | m.Vnode<unknown, unknown>;
    validate(value?: Date | undefined): boolean;
    getFormattedValue(): string;
    private _getPopupMode;
    protected _getButtons(): Button[];
    protected _getEditorAttrs(attrs: m.Attributes): m.Attributes;
}
export {};
//# sourceMappingURL=InputDate.d.ts.map