import m from 'mithril';
import { Editor, EditorAttributes, EditorEventTypes } from '../Editor';
import { Button } from '../..';
declare type PopupMode = true | false | 'onlyByButton' | 'onlyByFocus';
export declare type InputTimeAttributes = EditorAttributes<string> & {
    placeholder?: string;
    readonly?: boolean;
    popup?: PopupMode;
};
export declare class InputTime extends Editor<string, InputTimeAttributes, EditorEventTypes<string>> {
    private _btnShowPopup;
    private _popup;
    private _timepicker;
    constructor(attrs?: InputTimeAttributes);
    showPopup(target: PointerEvent | HTMLElement): void;
    setValue(value?: string | undefined): void;
    setDisabled(disabled: boolean): boolean;
    protected controlView(): m.Children | m.Vnode<unknown, unknown>;
    validate(value?: string | undefined): boolean;
    private _getPopupMode;
    protected _getButtons(): Button[];
    protected _getEditorAttrs(attrs: m.Attributes): m.Attributes;
}
export {};
//# sourceMappingURL=InputTime.d.ts.map