import m from 'mithril';
import './list.style.css';
import { Component, ComponentAttributes } from '../common/Component';
import { ValidEventTypes } from '../event-emitter/EventEmitter';
import { Data } from '../data/Data';
import { TemplateCallbackType } from '../common/Template';
import { Selection, SelectionAttributes } from '../selection/Selection';
import { DataItemType } from '../data/Types';
declare type ListAttributes = ComponentAttributes & {
    template?: TemplateCallbackType;
    selection?: SelectionAttributes;
};
export declare class List extends Component<ListAttributes, ValidEventTypes> {
    data: Data<DataItemType>;
    fitContainer: boolean;
    selection: Selection<DataItemType>;
    private _focusedIndex?;
    private _listNode?;
    private _activeKeyboardNavigation;
    private _eventHandlers;
    constructor(attrs?: ListAttributes, data?: Data<DataItemType>);
    view(): m.Children | m.Vnode<unknown, unknown>;
    isActiveKeyboardNavigation(): boolean;
    activateKeyboardNavigation(): void;
    deactivateKeyboardNavigation(): void;
}
export {};
//# sourceMappingURL=List.d.ts.map