import m from 'mithril';
import { Component, ComponentAttributes } from '../common/Component';
import { ValidEventTypes } from '../event-emitter/EventEmitter';
import './message.style.css';
import { Color } from '../common/Types';
import { Button } from '../controls/button/Button';
import { Container, ContainerAttributes } from '../common/Container';
export declare type MessageAttributes = ComponentAttributes & {
    title?: string;
    text?: string;
    color?: Color;
    modal?: boolean;
    buttons?: Button[];
};
declare type MessageEventsType = {
    afterHide: () => void;
};
export declare class Message extends Component<MessageAttributes, MessageEventsType> {
    private container?;
    private toolbar;
    protected modal: boolean;
    constructor(attrs?: MessageAttributes, container?: Container<ContainerAttributes, ValidEventTypes> | undefined);
    hide(): void;
    show(): void;
    getColor(): Color;
    view(): m.Children | m.Vnode<unknown, unknown>;
}
export {};
//# sourceMappingURL=Message.d.ts.map