import m from 'mithril';
import { Component, ComponentAttributes } from '../common/Component';
import { ValidEventTypes } from '../event-emitter/EventEmitter';
import { Color, IdType } from '../common/Types';
import './toast.style.css';
import { Container, ContainerAttributes } from '../common/Container';
export declare type ToastMessageAttributes = ComponentAttributes & {
    title?: string;
    text?: string;
    icon?: string;
    expirationMs?: number;
    color?: Color;
};
export declare class Toast extends Component<ComponentAttributes, ValidEventTypes> {
    private container?;
    private _messages;
    private _isDrawing;
    protected modal: boolean;
    constructor(attrs?: ComponentAttributes, container?: Container<ContainerAttributes, ValidEventTypes> | undefined);
    runDrawing(): void;
    show(config: ToastMessageAttributes): void;
    remove(id: IdType): void;
    view(): m.Children;
}
//# sourceMappingURL=Toast.d.ts.map