import { IDataComponent, IdType } from '../common/Types';
import { DataItemType } from '../data/Types';
export declare type SelectionAttributes = {
    multiple?: boolean;
    selected?: IdType[];
};
export declare type SelectionEventTypes = {
    afterSelect: (ids: IdType[]) => void;
    afterUnselect: (ids: IdType[]) => void;
};
export declare class Selection<T extends DataItemType> {
    private selectedItems;
    private readonly parent;
    private readonly attrs;
    constructor(parent: IDataComponent<T>, attrs?: SelectionAttributes);
    getSelected(): IdType[];
    isMultipleMode(): boolean;
    setMultipleMode(mode: boolean): void;
    unselect(id: IdType, suppressEvents?: boolean): void;
    select(id: IdType, config?: {
        ctrlKey?: boolean;
    }, suppressEvents?: boolean): void;
    selectAll(): void;
    unselectAll(): void;
    isSelected(id: IdType): boolean;
    setSelection(selection?: IdType[]): void;
}
//# sourceMappingURL=Selection.d.ts.map