import m from 'mithril';
import { Container, ContainerAttributes } from '../common/Container';
import { Tabs } from '..//tabs/Tabs';
import { TooltipAttrs } from '../messages/Tooltip';
declare type TabViewEventsType = {
    mouseover: (e: PointerEvent) => void;
    mouseout: (e: PointerEvent) => void;
};
export declare type TabViewAttributes = ContainerAttributes & {
    header?: string;
    disabled?: boolean;
    tooltip?: TooltipAttrs;
    icon?: string;
    closable?: boolean;
};
export declare class TabView extends Container<TabViewAttributes, TabViewEventsType> {
    private _parent;
    private _btnClose;
    constructor(attrs: TabViewAttributes, parent: Tabs);
    isDisabled(): boolean;
    enable(): void;
    disable(): void;
    isActive(): boolean;
    setActive(): void;
    close(): void;
    viewHeader(): m.Vnode<unknown, unknown>;
    view(): m.Vnode<unknown, unknown>;
}
export {};
//# sourceMappingURL=TabView.d.ts.map