import m from 'mithril';
import { Component, ComponentAttributes } from '../common/Component';
import { ValidEventTypes } from '../event-emitter/EventEmitter';
import './tabs.style.css';
import { TabView, TabViewAttributes } from './TabView';
import { IdType } from '../common/Types';
declare type TabsEventTypes = ValidEventTypes;
declare type TabsSide = 'top' | 'bottom' | 'left' | 'right';
declare type TabsAttributes = ComponentAttributes & {
    items: TabViewAttributes[];
    activeTabView?: IdType;
    side?: TabsSide;
};
export declare class Tabs extends Component<TabsAttributes, TabsEventTypes> {
    private _tabs;
    attrs: TabsAttributes;
    constructor(attrs: TabsAttributes);
    getSide(): TabsSide;
    setSide(side: TabsSide): void;
    getTabView(id: IdType): TabView | undefined;
    getActiveTabView(): TabView | undefined;
    add(config: TabViewAttributes): TabView;
    setActive(tabviewId: IdType): void;
    close(tabviewId: IdType): void;
    view(): m.Vnode<unknown, unknown>;
}
export {};
//# sourceMappingURL=Tabs.d.ts.map