import m from 'mithril';
import { Component, ComponentAttributes } from '../common/Component';
import './toolbar.style.css';
import { ValidEventTypes } from '../event-emitter/EventEmitter';
import { FlexJustification, IdType } from '../common/Types';
import { Control, ControlAttributes, ControlEventTypes } from '../controls/common/Control';
export declare type ToolbarAttributes = ComponentAttributes & {
    classNames?: string | string[];
    items?: Control<ControlAttributes, ControlEventTypes>[];
    justify?: FlexJustification;
};
export declare class Toolbar extends Component<ToolbarAttributes, ValidEventTypes> {
    constructor(attrs: ToolbarAttributes);
    getItem<T extends Control<ControlAttributes, ControlEventTypes>>(id: IdType): T | undefined;
    addItem(item: Control<ControlAttributes, ControlEventTypes>, index?: number): void;
    view(): m.Vnode<unknown, unknown>;
    getItems(): Control<ControlAttributes, ControlEventTypes>[];
}
//# sourceMappingURL=Toolbar.d.ts.map