import m from 'mithril';
import { Component, ComponentAttributes } from '../common/Component';
import { TreeData } from '../data/TreeData';
import { TemplateCallbackType } from '../common/Template';
import './tree.style.css';
import { IDataComponent, IdType } from '../common/Types';
import { Selection, SelectionAttributes, SelectionEventTypes } from '../selection/Selection';
import { TreeDataItemType } from '../data/Types';
declare type TreeEventTypes = SelectionEventTypes & {
    onClick: (e: PointerEvent) => void;
};
declare type TreeAttributes = ComponentAttributes & {
    template?: TemplateCallbackType;
    selection?: SelectionAttributes;
};
export declare class Tree extends Component<TreeAttributes, TreeEventTypes> implements IDataComponent<TreeDataItemType> {
    data: TreeData;
    selection: Selection<TreeDataItemType>;
    constructor(attrs: TreeAttributes);
    isCollapsed(id: IdType): boolean;
    expandAll(): void;
    collapseAll(): void;
    expand(id: IdType): void;
    collapse(id: IdType): void;
    toggle(id: IdType): void;
    view(): m.Vnode<unknown, unknown>;
}
export {};
//# sourceMappingURL=Tree.d.ts.map