import m from 'mithril';
import { ValidEventTypes } from '../event-emitter/EventEmitter';
import { Container, ContainerAttributes } from '../common/Container';
import './window.style.css';
import { SizeType } from '../common/Types';
export declare type WindowAttributes = ContainerAttributes & {
    modal?: boolean;
    title?: string;
    width?: number;
    maximized?: boolean;
    sizes?: SizeType;
    hidden?: boolean;
};
declare type WindowEventsType = {
    afterHide: () => void;
};
export declare class Window extends Container<WindowAttributes, WindowEventsType> {
    private container?;
    protected modal: boolean;
    private header;
    constructor(attrs?: WindowAttributes, container?: Container<ContainerAttributes, ValidEventTypes> | undefined);
    isHidden(): boolean;
    hide(): void;
    show(): void;
    restore(): void;
    maximize(): void;
    isMaximized(): boolean;
    view(): m.Children | m.Vnode<unknown, unknown>;
    private _refreshHeaderButtons;
    private _getSizes;
}
export {};
//# sourceMappingURL=Window.d.ts.map